

require "game_entities"
game={}
is_reloading=false
fire_cooldown=0
score=0
alive = true
--keeping it simple
enemy.x=200
enemy.y=200
enemy.img=nil
--offset
offset=math.pi/-2 --bottom of image face cursor
--offset=0 --right side face cursor
--offset=math.pi/2 --top of image face cursor
--offset=math.pi --left side of image face cursor

--super simple collision check
function CheckCollision(x1,y1,w1,h1,x2,y2,w2,h2)
	return x1<x2+w2 and
			   x2<x1+w1 and
			   y1<y2+h2 and
			   y2 < y1+h1
end

--handle gun reloading
function reload_gun()
	is_reloading=true
	local needed = gun.mag_max - gun.mag_count 
	if needed>0 then
		if player.ammo_count < needed then
			gun.mag_count=gun.mag_count+player.ammo_count
			player.ammo_count=0	
		else
			gun.mag_count=gun.mag_max
			player.ammo_count=player.ammo_count-needed
		end
		fire_cooldown=gun.reload_speed
	end
end

--keypress handler(s), but NOT for player movement as that will not need key releases and needs dt
function game.keypressed(key,scancode,isrepeat)
	if key == "space" then
		if alive==true then
			fire_gun()
		else
			state_to_title()
		end
	elseif key == "r" then
		reload_gun()
	elseif key == "e" then
		--interact button
		interact_with()
	elseif key == "q" then
		--inventory/pause button
		open_menu()
	elseif key == "escape" then
		--quit to title button
		state_to_title()
	end
end

function fire_gun()
end

function interact_with()
end

function open_menu()
end

function state_to_title()
	love.graphics.clear()
	global.state=state_intro
	intro.load()
end

function game.load()
	enemies={}
	bullets={}
	alive=true
	love.graphics.setBackgroundColor(0, 0, 0)
	print("STATE = in-game")
	player.img=love.graphics.newImage('assets/sprites/player.png')
	bullet.img = love.graphics.newImage('assets/sprites/bullet.png')
	enemy.img=love.graphics.newImage('assets/sprites/enemy.png')
	level = love.graphics.newImage('assets/sprites/level.png')
	score=0
	table.insert(enemies,enemy)
	local enemX ={x=300,y=125,img=enemy.img}
	table.insert(enemies,enemX)

end

function game.update(dt)
	if fire_cooldown >0 then
		fire_cooldown=fire_cooldown-1
	else
		is_reloading=false
	end
	--face mouse
	local mouseX,mouseY = love.mouse.getPosition()
	player.r=math.atan2(mouseY-(player.y),mouseX-(player.x))+offset
	--look for key input
	if love.keyboard.isDown("left","a")then
		player.x=player.x-100*dt
	end
	if love.keyboard.isDown("right","d")then
		player.x=player.x + 100 * dt
	end
	if love.keyboard.isDown("up","w")then
		player.y=player.y-100*dt
	end
	if love.keyboard.isDown("down","s")then
		player.y=player.y+100*dt
	end
	if love.mouse.isDown(1)then
		if fire_cooldown<1 and (gun.mag_count>0) and (is_reloading==false) then
			is_released=false
			local startX = player.x + math.cos(player.r)+ math.cos(player.r+math.pi/2)
			local startY = player.y + math.sin(player.r)+ math.sin(player.r+math.pi/2)
			local targetX,targetY = love.mouse.getPosition()
			local angle = math.atan2((targetY - startY),(targetX - startX))
			abullet={img=bullet.img,x=startX,y=startY,angle=angle}
			table.insert(bullets,abullet)
			gun.mag_count=gun.mag_count-1
			fire_cooldown=gun.fire_cooldown
		end
	end
	
	for i,v in pairs(bullets)do
		local Dx = 2550 * math.cos(v.angle)		--Physics: deltaX is the change in the x direction.
		local Dy = 2550 * math.sin(v.angle)
		v.x = v.x +  (Dx * dt)
		v.y = v.y + (Dy * dt)
		--Cleanup code, removes bullets that exceeded the boundries:
		if v.x > love.graphics.getWidth() or
		   v.y > love.graphics.getHeight() or
		   v.x < 0 or
		   v.y < 0 then
			table.remove(bullets,i)
			
		end
		--calculate collisions(have 2 arrays, one of enemies{} and one of walls{} so you can do "for i,v in pairs(enemies)"... "for k,x in pairs(bullets)"... as a nested
		--first check enemy vs player, to determine player hurt
		--next check enemy vs bullet for enemy hurt
		for j,w in pairs(enemies)do
			if CheckCollision(v.x,v.y,v.img:getWidth(),v.img:getHeight(),w.x,w.y,w.img:getWidth(),w.img:getHeight()) then
				table.remove(bullets,i)
				table.remove(enemies,j)
				score=score+1
			end
		end
		
	end			
	--really shitty enemy 'ai'
	for h,q in pairs(enemies)do
		if (q.x < love.graphics.getWidth() and q.x > 0) and (q.y < love.graphics.getHeight() and q.x > 0)then
			q.x=math.random(-10,10)+q.x
			q.y=math.random(-10,10)+q.y
		else 
			q.x=q.x+10 
			q.y=q.y+10
		end
		if CheckCollision(player.x,player.y,player.img:getWidth(),player.img:getHeight(),q.x,q.y,q.img:getWidth(),q.img:getHeight()) then
			alive=false
			love.graphics.setBackgroundColor(0, 0, 0)
			love.graphics.setColor(255,255,255)
		end
	end
end
	
function game.draw()

	if alive then
		love.graphics.draw(level,50,50)
		love.graphics.print("mag: "..gun.mag_count.."/"..gun.mag_max,25,25)
		love.graphics.print("ammo: "..player.ammo_count.."/"..player.ammo_max.."",100,25)
		love.graphics.print("SCORE: "..score.."",25,50)
		if is_reloading then
			love.graphics.print("*RELOADING*",25,0)
		end
		love.graphics.draw(player.img,player.x,player.y,player.r,1,1,player.img:getWidth()/2,player.img:getHeight()/2)
		for i,v in pairs(bullets)do
			love.graphics.draw(v.img,v.x,v.y,v.angle)
		end
		for j,w in pairs(enemies)do
			love.graphics.draw(w.img,w.x,w.y)
		end
	else
		love.graphics.print("game Over\nPress <SPACE> to return to the main menu",150,150)
	end
	
end



