
debug=true
--Game State(states defined in the constants file)
global={}
global.state=0
global.level=0

--determines if firing is allowed at this time (main use is to stop user holding down fire button, as well as for cutscenes later)
canFire=false
--for graphical/audio effect when reloading gun
isReloading=false
--firing delay/cooldown used to determine speed user can spam 'fire' action
firing_time=0
--check user is alive (checks health for this)
isAlive=true
require "intro"
require "game"
require "constants"


function reload()
end

function collisionCheck(x1,y1,w1,h1,x2,y2,w2,h2)
end

function amIAlive()
end

function love.load()
	love.keyboard.setKeyRepeat(false)
	love.graphics.setBackgroundColor(0, 0, 0)
	love.window.setMode(screenW, screenH, {fullscreen=false, vsync=true, msaa=0})
	love.window.setTitle(windowTitle .. " " .. windowVersion)

	
	if global.state== state_intro then
		intro.load()
	elseif global.state == state_game then
		game.load()
	elseif global.state == state_settings then
		settings.load()
	end	
	
end

function love.keypressed(key,scancode,isrepeat)
	if global.state == state_intro then
		intro.keypressed(key,scancode,isrepeat)
	elseif global.state == state_game then
		game.keypressed(key,scancode,isrepeat)
	end
end

function love.update(dt)

	if global.state== state_intro then
		intro.update(dt)
	elseif global.state == state_game then
		game.update(dt)
	elseif global.state == state_settings then
		settings.update(dt)
	end	

end

function love.draw()

	if global.state== state_intro then
		intro.draw()
	elseif global.state == state_game then
		game.draw()
	elseif global.state == state_settings then
		settings.draw()
	end	

end
 
